'use strict';

exports.__esModule = true;
exports.Provide = exports.Subscribe = exports.Container = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactContext = require('create-react-context');

var _createReactContext2 = _interopRequireDefault(_createReactContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var StateContext = (0, _createReactContext2.default)();

var Container = exports.Container = function () {
  function Container() {
    _classCallCheck(this, Container);

    this._listeners = [];
  }

  Container.prototype.setState = function setState(state) {
    this.state = Object.assign({}, this.state, state);
    this._listeners.forEach(function (fn) {
      return fn();
    });
  };

  Container.prototype._subscribe = function _subscribe(fn) {
    this._listeners.push(fn);
  };

  Container.prototype._unsubscribe = function _unsubscribe(fn) {
    this._listeners = this._listeners.filter(function (f) {
      return f !== fn;
    });
  };

  return Container;
}();

var Subscribe = exports.Subscribe = function (_React$Component) {
  _inherits(Subscribe, _React$Component);

  function Subscribe() {
    var _temp, _this, _ret;

    _classCallCheck(this, Subscribe);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onUpdate = function () {
      // ...
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  Subscribe.prototype.componentDidMount = function componentDidMount() {
    // ...
  };

  Subscribe.prototype.componentWillReceiveProps = function componentWillReceiveProps() {
    // ...
  };

  Subscribe.prototype.componentWillUnmount = function componentWillUnmount() {
    // ...
  };

  Subscribe.prototype._createInstances = function _createInstances(map, containers) {
    return containers.map(function (Container) {
      var container = map.get(Container);
      if (!container) {
        container = new Container();
        map.set(Container, container);
      }
      return container;
    });
  };

  Subscribe.prototype.render = function render() {
    var _this2 = this;

    return _react2.default.createElement(
      StateContext.Consumer,
      null,
      function (parentMap) {
        var childMap = new Map(parentMap);
        return _react2.default.createElement(
          StateContext.Provider,
          { value: childMap },
          _this2.props.children.apply(null, _this2._createInstances(childMap, _this2.props.to))
        );
      }
    );
  };

  return Subscribe;
}(_react2.default.Component);

var Provide = exports.Provide = function (_React$Component2) {
  _inherits(Provide, _React$Component2);

  function Provide() {
    _classCallCheck(this, Provide);

    return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
  }

  Provide.prototype.render = function render() {
    var map = new Map();

    this.props.inject.forEach(function (instance) {
      map.set(instance.constructor, instance);
    });

    return _react2.default.createElement(
      StateContext.Provider,
      { value: map },
      this.props.children
    );
  };

  return Provide;
}(_react2.default.Component);